""" The pdelab specific parts of the code generation process """

# Define the generators that are used throughout all pdelab specific code generations.
from dune.perftool.generation import symbol, instruction
from dune.perftool.loopy.transformer import quadrature_iname


def quadrature_preamble(code, **kw):
    return instruction(inames=quadrature_iname(), code=code, **kw)


# Now define some commonly used generators that do not fall into a specific category
@symbol
def name_index(index):
    from ufl.classes import MultiIndex, Index
    if isinstance(index, Index):
        return str(index)
    if isinstance(index, MultiIndex):
        assert len(index) == 1
        return str(index._indices[0])
